// checkbook program version 3 for Fundamentals of Computing

import java.io.*;

public class chkbk {
    // variables declared here are global and
    // can be used by any of the routines within this class
    static double CurrentBalance = 0.0; // current account
    // set up an input stream so we can read lines
    // from the keyboard
    static BufferedReader kbd = new BufferedReader(new InputStreamReader(System.in));


    public static void main(String args[])
        throws java.io.IOException
    {
        String buf; // input buffer
        int opt;    // menu option

        // initial message
        System.out.println("Welcome to the Java Checkbook Program");

        //
        // main loop
        //
        // keep displaying menu and getting options
        // until the user quits
        //
        do
        {
            System.out.println("Current balance is " + CurrentBalance);
            // main menu
            System.out.println("Options are:");
            System.out.println("1. Set Balance");
            System.out.println("2. Check");
            System.out.println("3. Deposit");
            System.out.println("4. MAC");
            System.out.println("5. Charge");
            System.out.println("9. Quit");

            // get menu option from user
            System.out.print("Enter Option: "); // prompt the user
            try
            {
            	buf = kbd.readLine();   // read what they type
            	opt = Integer.parseInt(buf);    // and convert to a number
            } catch (Exception e) { opt = 0; } // ignore option

            switch(opt)
            {
            case 1: set_balance(); break;
            case 2: process_check(); break;
            case 3: process_deposit(); break;
            case 4: process_mac(); break;
            case 5: process_chg(); break;
            case 9: System.out.println("Bye!"); break;
            default:
                System.out.println("Invalid option - try again");
            }

        } while (opt != 9);
        System.out.println("Thanks for using our program!  Come again!");
    } // end main routine

    public static void set_balance()
    { // get new account balance from user
        String buf;
        Double amt;

        System.out.print("Enter new balance: ");
        try
        {
        	buf = kbd.readLine();
        } catch (Exception e) { return; }
        amt = new Double(buf);
        CurrentBalance = amt.doubleValue();
    }

    public static void process_check()
    {
        xact x = new xact("Chk");

        x.getXact(CurrentBalance);
        CurrentBalance = x.getBal();    // new balance
        x.printXact();
    }

    public static void process_deposit()
    {
        xact x = new xact("Dep");

        x.getXact(CurrentBalance);
        CurrentBalance = x.getBal();    // new balance
        x.printXact();
    }

    public static void process_mac()
    {
        xact x;
        String buf;
        char ch;

        do
        {
            System.out.print("Transaction type (w, d, q): ");
            try
            {
            	buf = kbd.readLine();
            } catch (Exception e) { buf = ""; }
            if (buf.equalsIgnoreCase("w"))
            { // MAC withdrawl
                x = new xact("MACW");
            }
            else if (buf.equalsIgnoreCase("d"))
            { // MAC deposit
                x = new xact("MACD");
            }
            else
            { // invalid or quit
		if (!buf.equalsIgnoreCase("q"))
		{
                	System.err.println("Invalid option (" + buf + ")");
		}
                x = null;
            }

            if (x != null)
            {
            	x.getXact(CurrentBalance);
                CurrentBalance = x.getBal();
                x.printXact();
            }
        } while (!buf.equals("q"));
    }

    public static void process_chg()
    {
        xact x = new xact("Chg");

        x.getXact(CurrentBalance);
        CurrentBalance = x.getBal();    // new balance
        x.printXact();
    }
}

